SenderSharedGuilds = {}
 
SenderSharedGuilds.name = "SenderSharedGuilds"
SenderSharedGuilds.cache = {}
SenderSharedGuilds.control = nil

local MAX_GUILDS = 5

local function getsharedguilds (name, skip)
    local guilds = SenderSharedGuilds.cache[name]
    local gtext  = ""

    if guilds ~= nil then
        for k, v in pairs(guilds) do
            if skip ~= nil and v == skip then
            else
                if gtext ~= "" then
                    gtext = gtext .. ", "
                end
                gtext = gtext .. v
            end
        end

        if gtext ~= "" then
            gtext = gtext .. "."
        end
    end

    return gtext
end

function SenderSharedGuilds:Initialize()
    self:BuildRoster()

    local inbox = ZO_MailInboxMessage
    local from_label = ZO_MailInboxMessageReceivedLabel

    local c_name = inbox:GetName() .. "SharedGuildsLabel"
    local control = inbox:CreateControl(c_name, CT_LABEL)
    control:SetAnchor(BELOW, from_label, BOTTOMLEFT, 0, 5)
    control:SetFont('ZoFontWinH4')
    control:SetColor(GetInterfaceColor(INTERFACE_COLOR_TYPE_TEXT_COLORS, INTERFACE_TEXT_COLOR_NORMAL))
    control:SetText("Shared Guilds:")

    local c_name = inbox:GetName() .. "SharedGuilds"
    local control2 = inbox:CreateControl(c_name, CT_LABEL)
    control2:SetAnchor(LEFT, control, RIGHT, 5, 0)
    control2:SetFont('ZoFontWinH4')

    SenderSharedGuilds.control = control2

    local zo = ZO_MailInboxShared_UpdateInbox
    ZO_MailInboxShared_UpdateInbox = function (mailData, ...)
        zo(mailData, ...)

        local gtext = getsharedguilds(mailData.senderDisplayName)

        if gtext == "" then gtext = "None." end

        SenderSharedGuilds.control:SetText(gtext)
    end
    
    GUILD_ROSTER_KEYBOARD.DisplayName_OnMouseEnter = function (self, control)
        local row = control:GetParent()
        local data = ZO_ScrollList_GetData(row)

        local curguild = GetGuildName(GUILD_ROSTER_MANAGER.guildId)

        local gtext = getsharedguilds(data.displayName, curguild)

        local text = ""

        if (data.hasCharacter) then
            text = ZO_FormatUserFacingCharacterName(data.characterName)
        end

        if text ~= "" and gtext ~= "" then text = text .. "\n" end

        if gtext ~= "" then text = text .. "Shared guilds: " .. gtext end

        if(text ~= "") then
            InitializeTooltip(InformationTooltip)
            SetTooltipText(InformationTooltip, text)
            local textWidth = control:GetTextDimensions()
            InformationTooltip:ClearAnchors()
            InformationTooltip:SetAnchor(BOTTOM, control, TOPLEFT, textWidth * 0.5, 0)
        end

        self:EnterRow(row)
    end

end

function SenderSharedGuilds:BuildRoster()
    for i = 1, MAX_GUILDS do
        local gname = GetGuildName(i)
        if gname ~= "" then
            for l = 1, GetNumGuildMembers(i) do
                local name, _, _, _, _ = GetGuildMemberInfo(i, l)
                if SenderSharedGuilds.cache[name] == nil then
                    SenderSharedGuilds.cache[name] = {}
                end

                table.insert(SenderSharedGuilds.cache[name], gname)
            end
        end
    end
end
 
function SenderSharedGuilds.OnAddOnLoaded(event, addonName)
    if addonName == SenderSharedGuilds.name then
        SenderSharedGuilds:Initialize()
    end
end
 
EVENT_MANAGER:RegisterForEvent(SenderSharedGuilds.name, EVENT_ADD_ON_LOADED, SenderSharedGuilds.OnAddOnLoaded)
